<template>
  <div class="app-container">
    <el-row :gutter="20">
      <el-col :span="4" :xs="24">
        <div class="head-container">
          <el-input v-model="areaName" placeholder="请输入建筑名称" clearable size="small" prefix-icon="el-icon-search"
            style="margin-bottom: 20px" />
        </div>
        <div class="head-container">
          <el-tree :data="areaOptions" :props="defaultProps" :expand-on-click-node="false" :filter-node-method="filterNode" ref="tree"
            node-key="id" default-expand-all highlight-current @node-click="handleNodeClick" />
        </div>
      </el-col>
      <el-col :span="20" :xs="24">
        <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
          <el-form-item label="分区名称" prop="zoningName">
            <el-input v-model="queryParams.zoningName" placeholder="请输入分区名称" clearable @keyup.enter.native="handleQuery" />
          </el-form-item>
          <el-form-item label="区块标签" prop="tagCode">
            <el-select v-model="queryParams.tagCodeList" placeholder="请选择区块标签" multiple clearable :style="{width: '100%'}">
              <el-option v-for="item in emsTagOptions" :label="item.tagName" :value="item.tagCode" :key="item.tagCode" />
            </el-select>
          </el-form-item>
          <el-form-item>
            <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
            <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
          </el-form-item>
        </el-form>

        <el-row :gutter="10" class="mb8">
          <el-col :span="1.5">
            <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd" v-hasPermi="['basecfg:zoning:add']">新增
            </el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="success" plain icon="el-icon-edit" size="mini" :disabled="single" @click="handleUpdate"
              v-hasPermi="['basecfg:zoning:edit']">修改</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="danger" plain icon="el-icon-delete" size="mini" :disabled="multiple" @click="handleDelete"
              v-hasPermi="['basecfg:zoning:remove']">删除</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport"
              v-hasPermi="['basecfg:zoning:export']">导出</el-button>
          </el-col>
          <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
        </el-row>

        <el-table v-loading="loading" :data="zoningList" @selection-change="handleSelectionChange">
          <el-table-column type="selection" width="55" align="center" />
          <el-table-column label="分区名称" align="left" prop="zoningName" />
          <el-table-column label="分区编码" align="center" prop="zoningCode" width="200" />
          <el-table-column label="所在建筑" align="left" prop="areaPath" />
          <el-table-column label="区块标签" align="center">
            <template slot-scope="scope">
              <span v-for="tag in scope.row.tagNames" :key="tag" :style="getTagStyle(tag)" class="tag-label">
                {{ tag }}
              </span>
            </template>
          </el-table-column>
          <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
            <template slot-scope="scope">
              <el-button size="mini" type="text"  icon="el-icon-edit" @click="handleUpdate(scope.row)" v-hasPermi="['basecfg:zoning:edit']">
                修改</el-button>
              <el-button size="mini" type="text" icon="el-icon-delete" class="deleteBtn" @click="handleDelete(scope.row)" v-hasPermi="['basecfg:zoning:remove']">
                删除</el-button>
            </template>
          </el-table-column>
        </el-table>

        <pagination v-show="total>0" :total="total" :page.sync="queryParams.pageNum" :limit.sync="queryParams.pageSize"
          @pagination="getList" />

        <!-- 添加或修改建筑区域划分对话框 -->
        <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
          <el-form ref="form" :model="form" :rules="rules" label-width="100px">
            <el-form-item label="所属建筑" prop="bldgCode">
              <treeselect v-model="form.bldgCode" :options="areaOptions" :disable-branch-nodes="true" :show-count="true"
                placeholder="请选择所属建筑" />
            </el-form-item>
            <el-form-item label="楼层" prop="floor">
              <el-input v-model="form.floor" placeholder="请输入楼层" />
            </el-form-item>
            <el-form-item label="分区编码" prop="zoningCode">
              <el-input v-model="form.zoningCode" placeholder="请输入分区编码" />
            </el-form-item>
            <el-form-item label="分区名称" prop="zoningName">
              <el-input v-model="form.zoningName" placeholder="请输入分区名称" />
            </el-form-item>
            <el-form-item label="分区标签" prop="tagCodeList">
              <el-select v-model="form.tagCodeList" placeholder="请选择分区标签" multiple clearable style="width: 100%">
                <el-option v-for="item in emsTagOptions" :label="item.tagName" :value="item.tagCode" :key="item.tagCode" />
              </el-select>
            </el-form-item>
            <el-form-item label="建筑划分面积" prop="bldgLdArea">
              <el-input v-model="form.bldgLdArea" placeholder="请输入建筑划分面积" />
            </el-form-item>
            <el-form-item label="使用情况" prop="usageDetail">
              <el-input v-model="form.usageDetail" placeholder="请输入使用情况" />
            </el-form-item>
          </el-form>
          <div slot="footer" class="dialog-footer">
            <el-button type="primary" @click="submitForm">确 定</el-button>
            <el-button @click="cancel">取 消</el-button>
          </div>
        </el-dialog>
      </el-col>
    </el-row>
  </div>
</template>

<script>
import { listZoning, getZoning, delZoning, addZoning, updateZoning } from '@/api/basecfg/zoning'
import { getEmsTag } from '@/api/commonApi'
import { areaTreeSelect } from '@/api/basecfg/area'
import Treeselect from '@riophae/vue-treeselect'
import '@riophae/vue-treeselect/dist/vue-treeselect.css'

export default {
  name: "Zonin",
  components: { Treeselect },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 建筑区域划分表格数据
      zoningList: [],
      // 弹出层标题
      title: '',
      // 是否显示弹出层
      open: false,
      // 区域名称
      areaName: undefined,
      // 区域树选项
      areaOptions: undefined,
      // 标签选项
      emsTagOptions: undefined,
      defaultProps: {
        children: 'children',
        label: 'label'
      },
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        areaCode: null,
        bldgCode: null,
        zoningName: null,
        tagCodeList: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        zoningCode: [{ required: true, message: '分区编码不能为空', trigger: 'blur' }],
        zoningName: [{ required: true, message: '分区名称不能为空', trigger: 'blur' }]
      }
    }
  },
  watch: {
    // 根据名称筛选区域树
    areaName(val) {
      this.$refs.tree.filter(val)
    }
  },
  created() {
    this.getList()
    this.getAreaTree('Building')
    this.getEmsTag('Area')
  },
  methods: {

    formatDict(val, options, key = 'code', text = 'name') {
      let name = ''
      this[options].forEach(item => {
        if (val === item[key]) {
          name = item[text]
        }
      })
      return name
    },
    getTagStyle(tag) {
      const styleMap = {
        '公共区域': 'background-color: rgb(255,255,125); color: rgb(109,109,150); padding: 4px 8px; border-radius: 4px; width: 80px; height: 30px; margin: 4px 8px 4px 0; display: inline-block; vertical-align: top;',
        '商户区域': 'background-color: rgb(206,206,255); color: rgb(109,109,150); padding: 4px 8px; border-radius: 4px; width: 80px; height: 30px; margin: 4px 8px 4px 0; display: inline-block; vertical-align: top;',
        '热点区域': 'background-color: rgb(203,255,99); color: rgb(109,109,150); padding: 4px 8px; border-radius: 4px; width: 80px; height: 30px; margin: 4px 8px 4px 0; display: inline-block; vertical-align: top;'
      };
      return styleMap[tag] || 'background-color: #FFFFFF; color: #000000; padding: 4px 8px; border-radius: 4px; width: 80px; height: 30px; margin: 4px 8px 4px 0; display: inline-block; vertical-align: top;';
    },
    /** 查询建筑区域划分列表 */
    getList() {
      this.loading = true;
      listZoning(this.queryParams).then(response => {
        this.zoningList = response.rows.map(item => {
          // 将 tagNames 字符串转换为数组
          item.tagNames = item.tagNames.split(',').map(tag => tag.trim());
          return item;
        });
        this.total = response.total;
        this.loading = false;
      });
    },
    /** 查询区域树结构 */
    getAreaTree(tier) {
      areaTreeSelect(tier).then(response => {
        this.areaOptions = response.data
      })
    },
    // 筛选节点
    filterNode(value, data) {
      if (!value) return true
      return data.label.indexOf(value) !== -1
    },
    // 节点单击事件
    handleNodeClick(data) {
      if (data.tier === 'Area') {
        this.queryParams.areaCode = data.id
        this.queryParams.bldgCode = null
      } else if (data.tier === 'Building') {
        this.queryParams.areaCode = null
        this.queryParams.bldgCode = data.id
      }

      this.handleQuery()
    },
    // 取消按钮
    cancel() {
      this.open = false
      this.reset()
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        bldgCode: null,
        zoningCode: null,
        zoningName: null,
        floor: null,
        roomNo: null,
        bldgLdArea: null,
        usageDetail: null,
        tagCodeList: null
      }
      this.resetForm('form')
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1
      this.getList()
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.queryParams.bldgCode = null
      this.resetForm('queryForm')
      this.handleQuery()
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset()
      this.open = true
      this.title = '添加建筑区域划分'
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset()
      const id = row.id || this.ids
      getZoning(id).then(response => {
        this.form = response.data
        this.open = true
        this.title = '修改建筑区域划分'
      })
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs['form'].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateZoning(this.form).then(response => {
              this.$modal.msgSuccess('修改成功')
              this.open = false
              this.getList()
            })
          } else {
            addZoning(this.form).then(response => {
              this.$modal.msgSuccess('新增成功')
              this.open = false
              this.getList()
            })
          }
        }
      })
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids
      this.$modal
        .confirm('是否确认删除建筑区域划分编号为"' + ids + '"的数据项？')
        .then(function() {
          return delZoning(ids)
        })
        .then(() => {
          this.getList()
          this.$modal.msgSuccess('删除成功')
        })
        .catch(() => {})
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download(
        'ems/basecfg/area/building/zoning/export',
        {
          ...this.queryParams
        },
        `zoning_${new Date().getTime()}.xlsx`
      )
    },
    getEmsTag(tagModel) {
      getEmsTag(tagModel).then(response => {
        this.emsTagOptions = response.data
      })
    }
  }
}
</script>

